/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.HashMap;
import java.util.Vector;

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Table;

public class GrupoClase extends Composite {
	private Label labelGrupoMateria = null;
	private Combo comboMateriaClase = null;
	private ComboConId comboConIdMateriaClase = null;
	private Label labelParcial = null;
	private Combo comboParcial = null;
	private Table tableLista = null;
	private TableConId tableConIdLista = null;
	public GrupoClase(Composite parent, int style) {super(parent, style);initialize();}
	public void actualizar(){
		comboConIdMateriaClase.rellenarMateriaClase(false);
		comboConIdMateriaClase.seleccionarId(MateriaClase.getIdMateriaClaseDeTrabajo());
		Parcial.rellenarParciales(comboParcial);
		comboParcial.select(Parcial.getParcial(Fecha.fechaDeTrabajo)-1);
		listarEstudiantesNota();
	}
	private void initialize() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		GridData gridDataTableLista = new GridData();
		gridDataTableLista.horizontalSpan = 4;
		gridDataTableLista.verticalAlignment = GridData.FILL;
		gridDataTableLista.grabExcessHorizontalSpace = true;
		gridDataTableLista.grabExcessVerticalSpace = true;
		gridDataTableLista.horizontalAlignment = GridData.FILL;
		labelGrupoMateria = new Label(this, SWT.NONE);
		labelGrupoMateria.setText("Clase/Materia:");
		labelGrupoMateria.setToolTipText("Seleccione a la derecha el grupo de estudiantes y la materia sobre los que quiere trabajar.");
		GridLayout gridLayoutClase = new GridLayout();
		gridLayoutClase.horizontalSpacing = 2;
		gridLayoutClase.marginWidth = 2;
		gridLayoutClase.marginHeight = 2;
		gridLayoutClase.numColumns = 4;
		gridLayoutClase.verticalSpacing = 2;
		GridData gridDataClase = new GridData();
		gridDataClase.horizontalAlignment = GridData.FILL;
		gridDataClase.grabExcessHorizontalSpace = true;
		gridDataClase.grabExcessVerticalSpace = true;
		gridDataClase.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataClase);
		createComboGrupoMateria();
		this.setLayout(gridLayoutClase);
		this.setSize(new Point(685, 340));
		labelParcial = new Label(this, SWT.NONE);
		labelParcial.setText("Parcial:");
		labelParcial.setToolTipText("Seleccione a la derecha el parcial sobre el que quiere trabajar.");
		createComboParcial();
		tableLista = new Table(this, SWT.BORDER);
		tableLista.setHeaderVisible(true);
		tableLista.setLayoutData(gridDataTableLista);
		tableLista.setLinesVisible(true);
		tableConIdLista = new TableConId(tableLista);
		this.listarEstudiantesNota();
		tableLista.update();
		tableLista.addListener(SWT.MouseExit, new Listener() {public void handleEvent(Event arg0) {tableLista.setToolTipText("");}});
		tableLista.addListener(SWT.MouseMove, new Listener() {
	    	public void handleEvent(Event event) {
	    		Rectangle clientArea = tableLista.getClientArea();
	    		Point puntero = new Point(event.x, event.y);
			    int fila = tableLista.getTopIndex();
			    while (fila < tableLista.getItemCount()) {
			    	boolean visible = false;
			        TableItem item = tableLista.getItem(fila);
			        for (int columna = 0; columna < tableLista.getColumnCount(); columna++) {
			        	Rectangle rect = item.getBounds(columna);
			            if (rect.contains(puntero)) {
			            	tableLista.setToolTipText(tableConIdLista.getEmergente().get(fila).get(columna));
			            }
			            if (!visible && rect.intersects(clientArea)) {visible = true;}
			        }
			        if (!visible) return;
			        fila++;
			    }
	    	}
	    });
		final TableEditor editor = new TableEditor(tableLista);
		editor.horizontalAlignment = SWT.CENTER;
		editor.grabHorizontal = true;
		tableLista.addListener(SWT.MouseUp, new Listener() {
			public void handleEvent(Event event) {
				Rectangle clientArea = tableLista.getClientArea();
				Point puntero = new Point(event.x, event.y);
				int fila = tableLista.getTopIndex();
				while (fila < tableLista.getItemCount()) {
					boolean visible = false;
					final TableItem item = tableLista.getItem(fila);
					for (int columna = 0; columna < tableLista.getColumnCount(); columna++) {
						Rectangle rect = item.getBounds(columna);
						if (rect.contains(puntero)) {
							if (!tableConIdLista.getIdColumna().get(columna).equals("")) {
								final int fColumna = columna;
								final int fFila = fila;
								final String idEstudiante = tableConIdLista.getIdFila().get(fFila);
								final String idEvaluable = tableConIdLista.getIdColumna().get(fColumna);
								final String idEvalEvaluable = BBDD.consultarIdEvalEstudianteEvaluable(
										idEstudiante,idEvaluable);
								//System.out.println("idEvalEvaluable = "+idEvalEvaluable+" para Idfila = "+idEstudiante+" IdColumna = "+idEvaluable);
								if (idEvalEvaluable!=null) coloreaGrupoEvaluable(tableConIdLista,columna,fila,idEvalEvaluable);
								final Text text = new Text(tableLista, SWT.NONE);
								text.setToolTipText("Presione 'Escape (Esc)' para deshacer los cambios. Use coma ',' para los decimales");
								Listener textListener = new Listener() {
									public void handleEvent(final Event e) {
										String nota=null;
										switch (e.type) {
										case SWT.FocusOut:
											nota=editarNota(text.getText(),idEvaluable,idEstudiante);
											if (nota==null) nota=item.getText(fColumna);
											item.setText(fColumna, nota);
											text.dispose();
											break;
										case SWT.Traverse:
												switch (e.detail) {
													case SWT.TRAVERSE_RETURN:
														nota=editarNota(text.getText(),idEvaluable,idEstudiante);
														if (nota==null) nota=item.getText(fColumna);
														item.setText(fColumna, nota);
													case SWT.TRAVERSE_ESCAPE:
														nota=item.getText(fColumna);
														text.dispose();
														e.doit = false;
												}
												break;
										}
										if (nota!=null) {
											Color color=null;
											if (!nota.isEmpty()) {
												color = tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
														((Numero.numeroDecimal(nota)>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED));
											} else { 
												color = tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_BLACK);
											}
											item.setForeground(fColumna,color);
											//System.out.println("Nota = "+nota);
											if (idEvalEvaluable==null) {
												//System.out.println("idEval = null");
												if (nota!="")
													actualizaGrupoEvaluableTotales(tableConIdLista,nota,fColumna,fFila,
															BBDD.consultarIdEvalEstudianteEvaluable(idEstudiante,idEvaluable));
											} else 
												actualizaGrupoEvaluableTotales(tableConIdLista,nota,fColumna,fFila,idEvalEvaluable);
										}
									}
								};
								text.addListener(SWT.FocusOut, textListener);
								text.addListener(SWT.Traverse, textListener);
								editor.setEditor(text, item, columna);
								text.setText(item.getText(columna));
								text.selectAll();
								text.setFocus();
								return;
							}
						}
						if (!visible && rect.intersects(clientArea)) {visible = true;}
					}
					if (!visible) return;
					fila++;
				}
			}
		});
		actualizar();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() fin",true);
	}
	private void createComboGrupoMateria() {
		GridData gridDataComboGrupoMateria = new GridData();
		gridDataComboGrupoMateria.grabExcessHorizontalSpace = true;
		gridDataComboGrupoMateria.verticalAlignment = GridData.CENTER;
		gridDataComboGrupoMateria.horizontalAlignment = GridData.FILL;
		gridDataComboGrupoMateria.minimumWidth = 200;
		comboMateriaClase = new Combo(this,SWT.READ_ONLY);
		comboMateriaClase.setLayoutData(gridDataComboGrupoMateria);
		comboMateriaClase
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						//System.out.println("comboGrupoMateria");
						MateriaClase.fijarMateriaClase(comboConIdMateriaClase.idSeleccionado());
						Parcial.rellenarParciales(comboParcial);
						comboParcial.select(Parcial.getParcial(Fecha.fechaDeTrabajo)-1);
						listarEstudiantesNota();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboMateriaClase.setToolTipText("Seleccione el grupo de estudiantes y la materia sobre los que quiere trabajar.");
		comboConIdMateriaClase = new ComboConId(comboMateriaClase);
	}
	private void createComboParcial() {
		GridData gridDataComboParcial = new GridData();
		gridDataComboParcial.widthHint = 60;
		comboParcial = new Combo(this,SWT.READ_ONLY);
		comboParcial.setLayoutData(gridDataComboParcial);
		comboParcial
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						//System.out.println("comboParcial");
						Parcial.setParcialDeTrabajo(comboParcial.getSelectionIndex()+1);
						listarEstudiantesNota();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboParcial.setToolTipText("Seleccione el parcial sobre el que quiere trabajar.");
		Parcial.rellenarParciales(comboParcial);
	}
	private String editarNota(String texto, String idEvaluable, String idEstudiante){
		String idEvaluacion=BBDD.consultarIdEvalEstudianteEvaluable(idEstudiante,idEvaluable);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+texto+","+idEvaluable+","+idEstudiante+")");
		String idNuevo=null;
		String nota=null;
		if (texto.equals("")){
			if (idEvaluacion!=null) {
				Vector<Vector<String>> evaluacion = BBDD.consultarEval(idEvaluacion);
				if (evaluacion.get(0).get(4).equals("")){
					BBDD.borrarEvalEvaluable(idEvaluacion);
					nota="";
				} else {
					if (evaluacion.get(0).get(2).equals("0")){
						BBDD.borrarEvalEvaluable(idEvaluacion);
						nota="";
					} else {
						BBDD.modificarNotaEvalEvaluable("0", idEvaluacion);
						nota="0";
					}
				}
			}
		} else {
			nota=Numero.validarNumeroDecimal(texto,Numero.notaMax,true);
			if (nota!=null) {
				if (idEvaluacion==null) {
					idNuevo = BBDD.insertarEvalEstudianteEvaluable(idEstudiante, idEvaluable, nota);
				} else {
					BBDD.modificarNotaEvalEvaluable(nota, idEvaluacion);
				}
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+texto+","+idEvaluable+","+idEstudiante+") => idNuevo "+idNuevo);
		return nota;
	}
	private void actualizaGrupoEvaluableTotales(TableConId tableConIdLista,String mNota, int mColumna, int mFila, String idEvalEvaluable){
		Vector<Vector<String>> evaluables=new Vector<Vector<String>>();
		Vector<Vector<String>> tiposEvaluable=new Vector<Vector<String>>();
		//System.out.println("  /Consultando estudiantes de la EvalEvaluable("+idEvalEvaluable+")");
		Vector<Vector<String>> estudiantes = BBDD.consultarIdEstudiantesEvalEvaluable(idEvalEvaluable);
		//System.out.println("  \\estudiantes="+evaluables.size());
		Color color=null;
		//System.out.println("Actulizando grupo Evaluable nota = "+mNota+" columna = "+mColumna+" fila = "+mFila+" Evaluable = "+idEvalEvaluable);
		//System.out.println("  /Consultando Evaluables de la materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
		evaluables=BBDD.consultarEvaluablesMateriaClaseParcial(
				comboConIdMateriaClase.idSeleccionado(),
				comboParcial.getSelectionIndex()+1);
		//System.out.println("  \\Evaluables="+evaluables.size());
		HashMap<String,Double> tipoMinimo = new HashMap<String,Double>();
		//System.out.println("  /Consultando tipos de Evaluable de la materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
		tiposEvaluable=BBDD.consultarTiposEvaluableMateriaClaseParcial(
				comboConIdMateriaClase.idSeleccionado(),
				comboParcial.getSelectionIndex()+1);
		//System.out.println("  \\tipos="+tiposEvaluable.size());
		if (tiposEvaluable!=null) {
			for (int i=0;i<tiposEvaluable.size();i++){
				//System.out.println("tipo:"+tiposEvaluable.get(i).get(0)+" minimo:"+Double.parseDouble(tiposEvaluable.get(i).get(4)));
			    tipoMinimo.put(tiposEvaluable.get(i).get(0), Double.parseDouble(tiposEvaluable.get(i).get(4)));
			}
		}
		if (!mNota.isEmpty()) {
			color = tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
					((Numero.numeroDecimal(mNota)>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED));
		} else { 
			color = tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_BLACK);
			mNota="";
		}
		for (int i=0;i<estudiantes.size();i++) {
			int nfila = tableConIdLista.getIdFila().indexOf(estudiantes.get(i).get(0));
			TableItem fila = tableConIdLista.getObjetoTable().getItem(nfila);
			fila.setText(mColumna, mNota);
			fila.setForeground(mColumna,color);
			
			Vector<Vector<String>> notas = null;
			//System.out.println("  /Consultando notas del estudiante("+estudiantes.get(i).get(0)+") materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
			notas=BBDD.consultarEvalEvaluablesPorEstudianteEnMateriaClaseParcial(
					estudiantes.get(i).get(0),
					comboConIdMateriaClase.idSeleccionado(),
					comboParcial.getSelectionIndex()+1);
			//System.out.println("  \\notas="+notas.size());
			HashMap<String,Double> sumaTipoEvaluable = new HashMap<String,Double>();
			HashMap<String,Double> pesoTipoEvaluable = new HashMap<String,Double>();
			Vector<String> tipoHayMenorMinimo = new Vector<String>();
			for (int j=0;j<notas.size();j++) {
				if (!notas.get(j).get(0).equals(idEvalEvaluable) || !mNota.equals("")) {
					int columna=tableConIdLista.getIdColumna().indexOf(notas.get(j).get(1));
					//System.out.println("   Nota estudiante "+estudiantes.get(i).get(0)+" Evaluable "+notas.get(j).get(1)+"( columna "+columna+"):"+notas.get(j).get(2));
					String tipo = evaluables.get(columna-1).get(9);
					Double nota = new Double(notas.get(j).get(2));

					if (tipoHayMenorMinimo.indexOf(tipo)<0) 
						if (tipoMinimo.containsKey(tipo))
							if (nota<tipoMinimo.get(tipo)) tipoHayMenorMinimo.add(tipo);
					//System.out.println("tipo:"+tipo+" nota:"+nota+" minimo:"+tipoMinimo.get(tipo));
					Double peso = new Double(evaluables.get(columna-1).get(8));
					if (sumaTipoEvaluable.containsKey(tipo)){
						sumaTipoEvaluable.put(tipo, sumaTipoEvaluable.get(tipo)+(nota*peso));
						pesoTipoEvaluable.put(tipo, pesoTipoEvaluable.get(tipo)+peso);
					} else {
						sumaTipoEvaluable.put(tipo, (nota*peso)); 
						pesoTipoEvaluable.put(tipo, peso);
					}
					//System.out.println("idEvalAct nota("+notas.get(j).get(0)+") != ("+idEvalEvaluable+") "+!notas.get(j).get(0).equals(idEvalEvaluable)+" mNota ("+mNota+") "+!mNota.equals("")+" tipo ("+tipo+") suma = "+sumaTipoEvaluable.get(tipo)+" peso = "+pesoTipoEvaluable.get(tipo));
				} else if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("idEvalAct ("+idEvalEvaluable+") mNota ("+mNota+") Descarta la nota si va a ser borranda");
			}
			Double sumaTipoEvaluableTotal = new Double(0);
			Double pesoTipoEvaluableTotal = new Double(0);
			boolean tieneAlgunaNota = false;
			//System.out.println("  tipos="+tiposEvaluable.size());
			for (int j=0;j<tiposEvaluable.size();j++){
				int columna=tableConIdLista.getObjetoTable().getColumnCount()-tiposEvaluable.size()-1+j;
				if (sumaTipoEvaluable.containsKey(tiposEvaluable.get(j).get(0))) {
					Double nota = sumaTipoEvaluable.get(tiposEvaluable.get(j).get(0))/pesoTipoEvaluable.get(tiposEvaluable.get(j).get(0));
					if (tipoHayMenorMinimo.indexOf(tiposEvaluable.get(j).get(0))<0) {
						//System.out.println("Poniendo a '"+Numero.cadena(nota)+"' tipo "+tiposEvaluable.get(j).get(0));
						fila.setText(columna,Numero.cadena(nota));
					    fila.setForeground(columna,
					    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
					    				((nota>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
					    		));
					} else {
						fila.setText(columna,"-");
						fila.setForeground(columna,
				    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
				    				SWT.COLOR_RED
				    		));						
					}
					Double peso = new Double(tiposEvaluable.get(j).get(3));
					sumaTipoEvaluableTotal=sumaTipoEvaluableTotal+(nota*peso);
					pesoTipoEvaluableTotal=pesoTipoEvaluableTotal+peso;
					//System.out.println("Total tipo ("+tiposEvaluable.get(j).get(0)+") suma = "+sumaTipoEvaluableTotal+" peso = "+pesoTipoEvaluableTotal);
					tieneAlgunaNota=true;
				} else {
					//System.out.println("Poniendo a '' tipo "+tiposEvaluable.get(j).get(0));
					fila.setText(columna,"");
					fila.setForeground(columna,tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_BLACK));					
				}
			}
			int columna=tableConIdLista.getObjetoTable().getColumnCount()-1;
			if (tieneAlgunaNota) {
				double notaTotal=sumaTipoEvaluableTotal/pesoTipoEvaluableTotal;
				if (tipoHayMenorMinimo.size()==0) {
					fila.setText(columna,Numero.cadena(notaTotal));
					fila.setForeground(columna,
			    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
			    				((notaTotal>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
			    		));
				} else {
					fila.setText(columna,"-");
					fila.setForeground(columna,
			    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
			    				SWT.COLOR_RED
			    		));
					
				}
			} else {
				fila.setText(columna,"");
				fila.setForeground(columna,tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_BLACK));					
			}
		}
		if (mNota=="") {
			BBDD.borrarEvalEvaluable(idEvalEvaluable);
			//System.out.println("Borrando evaluación de la modificada nota=''");
		}
	}
	private void coloreaGrupoEvaluable(TableConId tableConIdLista, int columna, int fila, String idEvalEvaluable){
		Vector<Vector<String>> tabla = BBDD.consultarIdEstudiantesEvalEvaluable(idEvalEvaluable);
		//System.out.println("Coloreando grupo Evaluable columna = "+columna+" fila = "+fila+" Evaluable = "+idEvalEvaluable);
		for (int i=0;i<tabla.size();i++) {
			int ifila = tableConIdLista.getIdFila().indexOf(tabla.get(i).get(0));
			tableConIdLista.getObjetoTable().getItem(ifila).setForeground(columna,
					tableConIdLista.getObjetoTable().getDisplay().getSystemColor(SWT.COLOR_GRAY));
		}
	}
	public void listarEstudiantesNota(){
		Vector<Vector<String>> estudiantes=new Vector<Vector<String>>();
		Vector<Vector<String>> evaluables=new Vector<Vector<String>>();
		Vector<Vector<String>> tiposEvaluable=new Vector<Vector<String>>();
		TableColumn tableColumnLista = null;
		tableConIdLista.borrar();
		//System.out.println("\n\nActualizandoTabla---------------------------------------------------------------------------------");
		//System.out.println(" Limpiado datos... filas("+tableConIdLista.getObjetoTable().getItemCount()+") columnas("+tableConIdLista.getObjetoTable().getColumnCount()+") IdColumna("+tableConIdLista.getIdColumna().size()+") IdFila("+tableConIdLista.getIdFila().size()+")");
		//System.out.println(" Añadiendo datos...");
		if (comboConIdMateriaClase.idSeleccionado()!=null) {
			//System.out.println("  /Consultando estudiantes...Materia "+comboConIdGrupoMateria.idSeleccionado());
			estudiantes=BBDD.consultarEstudiantesMateriaClase(comboConIdMateriaClase.idSeleccionado(),null);
			//System.out.println("  \\Estudiantes="+estudiantes.size());
			if (estudiantes.size()>0) {
			    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
			    tableColumnLista.setText("Estudiante");
			    tableConIdLista.getIdColumna().add("");
				//System.out.println("  /Consultando Evaluables de la materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
				evaluables=BBDD.consultarEvaluablesMateriaClaseParcial(
						comboConIdMateriaClase.idSeleccionado(),
						comboParcial.getSelectionIndex()+1);
				//System.out.println("  \\Evaluables="+evaluables.size());
				if (evaluables!=null) {
					for (int i=0;i<evaluables.size();i++){
					    Calendar fecha = Calendar.getInstance();
					    fecha.set(Integer.parseInt(evaluables.get(i).get(1)),Integer.parseInt(evaluables.get(i).get(2)),Integer.parseInt(evaluables.get(i).get(3)),Integer.parseInt(evaluables.get(i).get(4)),Integer.parseInt(evaluables.get(i).get(5)));
					    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
					    tableColumnLista.setText((evaluables.get(i).get(6).equals(""))?"...":evaluables.get(i).get(6));
					    tableColumnLista.setToolTipText(
					    		"Fin/Entrega: "+Fecha.formaFechaDiaHora(fecha)+"\n"+
					    		"Enunciado: "+evaluables.get(i).get(7)+"\n"+
					    		"Tipo: "+evaluables.get(i).get(11)+"\n"+
					    		"Peso dentro del tipo de evaluable: "+Numero.cadenaEntero(Integer.parseInt(evaluables.get(i).get(8))));
					    tableConIdLista.getIdColumna().add(evaluables.get(i).get(0));
						//System.out.println("  Añadiendo columna Evaluable "+evaluables.get(i).get(0)+":"+evaluables.get(i).get(6));
					    tableColumnLista.setWidth(80);
					    tableColumnLista.pack();
					    tableColumnLista.setAlignment(SWT.CENTER);
					}
				}
				HashMap<String,Double> tipoMinimo = new HashMap<String,Double>();
				//System.out.println("  /Consultando tipos de Evaluable de la materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
				tiposEvaluable=BBDD.consultarTiposEvaluableMateriaClaseParcial(
						comboConIdMateriaClase.idSeleccionado(),
						comboParcial.getSelectionIndex()+1);
				//System.out.println("  \\tipos="+tiposEvaluable.size());
				if (tiposEvaluable!=null) {
					for (int i=0;i<tiposEvaluable.size();i++){
					    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
					    tableColumnLista.setText(tiposEvaluable.get(i).get(1));
					    tableColumnLista.setToolTipText(
					    		"Enunciado: "+tiposEvaluable.get(i).get(2)+"\n"+
					    		"Mínimo para subtotal: "+Numero.cadenaDecimal(Double.parseDouble(tiposEvaluable.get(i).get(4)))+"\n"+
							    "Peso en el Total: "+Numero.cadenaEntero(Integer.parseInt(tiposEvaluable.get(i).get(3))));
					    tableConIdLista.getIdColumna().add("");
						//System.out.println("  Añadiendo columna tipo Evaluable "+evaluables.get(i).get(0)+":"+evaluables.get(i).get(6));
					    tableColumnLista.setWidth(80);
					    tableColumnLista.pack();
					    tableColumnLista.setAlignment(SWT.CENTER);
					    //System.out.println("tipo:"+tiposEvaluable.get(i).get(0)+" minimo:"+Double.parseDouble(tiposEvaluable.get(i).get(4)));
					    tipoMinimo.put(tiposEvaluable.get(i).get(0), Double.parseDouble(tiposEvaluable.get(i).get(4)));
					}
				}
			    tableColumnLista = new TableColumn(tableConIdLista.getObjetoTable(), SWT.NONE);
			    tableColumnLista.setText("Total");
			    tableConIdLista.getIdColumna().add("");
			    tableColumnLista.pack();
			    tableColumnLista.setAlignment(SWT.LEFT);
				Vector<String> emergenteFila;
				for (int i=0;i<estudiantes.size();i++){
					//System.out.println("  Creando Fila estudiante: "+estudiantes.get(i).get(0));
					emergenteFila = new Vector<String>();
					tableConIdLista.getIdFila().addElement(estudiantes.get(i).get(0));
					TableItem fila = new TableItem(tableConIdLista.getObjetoTable(), SWT.NONE);
					String columnas[] = new String[tableConIdLista.getObjetoTable().getColumnCount()];
					for (int j=0;j<columnas.length;j++) {
						columnas[j]="";
						if (j==0)  {
							String emergenteCelda=
									estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"
									+"Datos: "+((estudiantes.get(i).get(3)!=null)?estudiantes.get(i).get(3):"");
							emergenteFila.addElement(emergenteCelda);
						} else if (j<=((evaluables!=null)?evaluables.size():0)) {
						    Calendar fecha = Calendar.getInstance();
						    fecha.set(Integer.parseInt(evaluables.get(j-1).get(1)),Integer.parseInt(evaluables.get(j-1).get(2)),Integer.parseInt(evaluables.get(j-1).get(3)),Integer.parseInt(evaluables.get(j-1).get(4)),Integer.parseInt(evaluables.get(j-1).get(5)));
							emergenteFila.addElement(
									"Estudiante: "+estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"
									+"Tipo: "+evaluables.get(j-1).get(11)+"\n"
									+"Enunciado: "+evaluables.get(j-1).get(7)+"\n"
									+"Peso: "+Numero.cadenaEntero(Integer.parseInt(evaluables.get(j-1).get(8)))+" Fin/Entrega: "+Fecha.formaFechaDiaHora(fecha));							
						} else if (j==columnas.length-1) {emergenteFila.addElement(emergenteFila.get(0));
						} else {emergenteFila.addElement("");}
					}
					columnas[0]=estudiantes.get(i).get(1)+", "+estudiantes.get(i).get(2);
					fila.setText(columnas);
					Vector<Vector<String>> notas = null;
					//System.out.println("  /Consultando notas del estudiante("+estudiantes.get(i).get(0)+") materia("+comboConIdGrupoMateria.idSeleccionado()+") parcial("+Integer.toString(comboParcial.getSelectionIndex()+1)+")");
					notas=BBDD.consultarEvalEvaluablesPorEstudianteEnMateriaClaseParcial(
							estudiantes.get(i).get(0),
							comboConIdMateriaClase.idSeleccionado(),
							comboParcial.getSelectionIndex()+1);
					//System.out.println("  \\notas="+notas.size());
					HashMap<String,Double> sumaTipoEvaluable = new HashMap<String,Double>();
					HashMap<String,Double> pesoTipoEvaluable = new HashMap<String,Double>();
					Vector<String> tipoHayMenorMinimo = new Vector<String>();
					if (notas!=null){
						for (int j=0;j<notas.size();j++) {
							int columna=tableConIdLista.getIdColumna().indexOf(notas.get(j).get(1));
							//System.out.println("   Nota estudiante "+estudiantes.get(i).get(0)+" evaluable "+notas.get(j).get(1)+"( columna "+columna+"):"+notas.get(j).get(2));
							fila.setText(columna,Numero.cadenaDecimal(Double.parseDouble(notas.get(j).get(2))));
						    fila.setForeground(columna,
						    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
						    				((Float.parseFloat(notas.get(j).get(2))>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)));
						    Calendar fecha = Calendar.getInstance();
						    fecha.set(Integer.parseInt(evaluables.get(columna-1).get(1)),Integer.parseInt(evaluables.get(columna-1).get(2)),Integer.parseInt(evaluables.get(columna-1).get(3)),Integer.parseInt(evaluables.get(columna-1).get(4)),Integer.parseInt(evaluables.get(columna-1).get(5)));
							emergenteFila.set(columna,emergenteFila.get(columna)+"\n"
									+"Grupo: "+notas.get(j).get(4)+"\n"
									+"Observaciones: "+notas.get(j).get(3));
							Double nota = new Double(notas.get(j).get(2));
							String tipo = evaluables.get(columna-1).get(9);
							//System.out.println("tipo:"+tipo+" nota:"+nota+" minimo:"+tipoMinimo.get(tipo));
							if (tipoHayMenorMinimo.indexOf(tipo)<0) 
								if (tipoMinimo.containsKey(tipo))
									if (nota<tipoMinimo.get(tipo)) tipoHayMenorMinimo.add(tipo);
							Double peso = new Double(evaluables.get(columna-1).get(8));
							if (sumaTipoEvaluable.containsKey(tipo)){
								sumaTipoEvaluable.put(tipo, sumaTipoEvaluable.get(tipo)+(nota*peso));
								pesoTipoEvaluable.put(tipo, pesoTipoEvaluable.get(tipo)+peso);
							} else {
								sumaTipoEvaluable.put(tipo, (nota*peso)); 
								pesoTipoEvaluable.put(tipo, peso);
							}
							//System.out.println("tipo ("+tipo+") suma = "+sumaTipoEvaluable.get(tipo)+" peso = "+pesoTipoEvaluable.get(tipo));
						}
					}
					Double sumaTipoEvaluableTotal = new Double(0);
					Double pesoTipoEvaluableTotal = new Double(0);
					boolean tieneAlgunaNota = false;
					if (tiposEvaluable!=null) {
						for (int j=0;j<tiposEvaluable.size();j++){
							int columna=tableConIdLista.getObjetoTable().getColumnCount()-tiposEvaluable.size()-1+j;
							if (sumaTipoEvaluable.containsKey(tiposEvaluable.get(j).get(0))) {
								Double nota = sumaTipoEvaluable.get(tiposEvaluable.get(j).get(0))/pesoTipoEvaluable.get(tiposEvaluable.get(j).get(0));
								if (tipoHayMenorMinimo.indexOf(tiposEvaluable.get(j).get(0))<0) {
									fila.setText(columna,Numero.cadena(nota));
								    fila.setForeground(columna,
								    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
								    				((nota>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
								    		));
								} else {
									fila.setText(columna,"-");
									fila.setForeground(columna,
							    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
							    				SWT.COLOR_RED
							    		));
								}
								Double peso = new Double(tiposEvaluable.get(j).get(3));
								sumaTipoEvaluableTotal=sumaTipoEvaluableTotal+(nota*peso);
								pesoTipoEvaluableTotal=pesoTipoEvaluableTotal+peso;
								//System.out.println("Total tipo ("+tiposEvaluable.get(j).get(0)+") suma = "+sumaTipoEvaluableTotal+" peso = "+pesoTipoEvaluableTotal);
								tieneAlgunaNota=true;
							}
							emergenteFila.set(columna,
									"Estudiante: "+estudiantes.get(i).get(1)+","+estudiantes.get(i).get(2)+"\n"+
						    		"Tipo: "+tiposEvaluable.get(j).get(2)+"\n"+
						    		"Peso en Total: "+Numero.cadenaEntero(Integer.parseInt(tiposEvaluable.get(j).get(3))));
						}
					}
					int columna=tableConIdLista.getObjetoTable().getColumnCount()-1;
					if (tieneAlgunaNota) {
						double notaTotal=sumaTipoEvaluableTotal/pesoTipoEvaluableTotal;
						if (tipoHayMenorMinimo.size()==0) {
							fila.setText(columna,Numero.cadena(notaTotal));
							fila.setForeground(columna,
					    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
					    				((notaTotal>=5)?SWT.COLOR_DARK_GREEN:SWT.COLOR_RED)
					    		));
						} else {
							fila.setText(columna,"-");
							fila.setForeground(columna,
					    		tableConIdLista.getObjetoTable().getDisplay().getSystemColor(
					    				SWT.COLOR_RED
					    		));
							
						}
					}
					tableConIdLista.getEmergente().add(emergenteFila);
				}
				tableConIdLista.getObjetoTable().getColumn(0).pack();
			}
		}
	}
}
